#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_odeiv.h>

gsl_matrix *a1, *b1, *c1, *e1;
gsl_matrix *a2, *b2, *c2, *e2;
gsl_matrix *p2, *q2, *p3, *q3, *r3;
gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;
gsl_matrix *inv_a1;
gsl_matrix *inv_a2;
gsl_matrix *inv_p2;
gsl_matrix *inv_p3;
gsl_matrix *pf1_m;
gsl_matrix *pf2_m;
gsl_matrix *pf11_m;
gsl_matrix *pf12_m;
gsl_matrix *pf21_m;
gsl_matrix *pf22_m;
double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;

void move(double y, double yy, double *val, int (*sys_y)(double, const double, double *, void *));
void move_y1(double y1, double yy1, double *val);
int sys_y1(double y1, const double *y, double *val, double *params);
void move_y2(double y2, double yy2, double *val);
int sys_y2(double y2, const double *y, double *val, double *params);

void set_abce_1(double x11, double x12, double x22, double y1, double y2, double r);
void set_abce_2(double x11, double x12, double x22, double y1, double y2, double r);
void set_pqr(double x11, double x12, double x22, double y1, double y2, double r);
void set_dbcqr(double x11, double x12, double x22, double y1, double y2, double r);
void pf1(double x11, double x12, double x22, double y1, double y2, double r);
void pf2(double x11, double x12, double x22, double y1, double y2, double r);
void pf11(double x11, double x12, double x22, double y1, double y2, double r);
void pf12(double x11, double x12, double x22, double y1, double y2, double r);
void pf21(double x11, double x12, double x22, double y1, double y2, double r);
void pf22(double x11, double x12, double x22, double y1, double y2, double r);
void invmat(gsl_matrix *m, gsl_matrix *invm);
void gsl_matrix_show(gsl_matrix *mat);

int main()
{
extern gsl_matrix *a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *q2, *p3, *p3, *r3;
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;
extern gsl_matrix *inv_a1;
extern gsl_matrix *inv_a2;
extern gsl_matrix *inv_p2;
extern gsl_matrix *inv_p3;
extern gsl_matrix *pf1_m;
extern gsl_matrix *pf2_m;
extern gsl_matrix *pf11_m;
extern gsl_matrix *pf12_m;
extern gsl_matrix *pf21_m;
extern gsl_matrix *pf22_m;

a1 = gsl_matrix_alloc(4, 4);
b1 = gsl_matrix_alloc(4, 4);
c1 = gsl_matrix_alloc(4, 1);
e1 = gsl_matrix_alloc(4, 2);
a2 = gsl_matrix_alloc(4, 4);
b2 = gsl_matrix_alloc(4, 4);
c2 = gsl_matrix_alloc(4, 1);
e2 = gsl_matrix_alloc(4, 2);
p2 = gsl_matrix_alloc(1, 1);
q2 = gsl_matrix_alloc(1, 4);
p3 = gsl_matrix_alloc(2, 2);
q3 = gsl_matrix_alloc(2, 1);
r3 = gsl_matrix_alloc(2, 4);
db11 = gsl_matrix_alloc(4, 4);
db12 = gsl_matrix_alloc(4, 4);
db21 = gsl_matrix_alloc(4, 4);
db22 = gsl_matrix_alloc(4, 4);
dc11 = gsl_matrix_alloc(4, 1);
dc12 = gsl_matrix_alloc(4, 1);
dc21 = gsl_matrix_alloc(4, 1);
dc22 = gsl_matrix_alloc(4, 1);
dq21 = gsl_matrix_alloc(1, 4);
dq22 = gsl_matrix_alloc(1, 4);
dq31 = gsl_matrix_alloc(2, 1);
dq32 = gsl_matrix_alloc(2, 1);
dr31 = gsl_matrix_alloc(2, 4);
dr32 = gsl_matrix_alloc(2, 4);
inv_a1 = gsl_matrix_alloc(4, 4);
inv_a2 = gsl_matrix_alloc(4, 4);
inv_p2 = gsl_matrix_alloc(1, 1);
inv_p3 = gsl_matrix_alloc(2, 2);
pf1_m = gsl_matrix_alloc(4, 4);
pf2_m = gsl_matrix_alloc(4, 4);
pf11_m = gsl_matrix_alloc(4, 4);
pf12_m = gsl_matrix_alloc(4, 4);
pf21_m = gsl_matrix_alloc(4, 4);
pf22_m = gsl_matrix_alloc(4, 4);

extern double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;
	g_x11 = -3; g_x12 = 0.5; g_x22 = 0.15; g_y1 = 1; g_y2 = 0.15; g_r = 1;

	double val[] = {2.948670364423784504,0.5817985920578351965,0.4754127542095007750,0.6566284657983176130};
	move(g_y1, 1.5, val, sys_y1);
	g_y1 = 1.5;
	move(g_y2, 0.5, val, sys_y2);
}

/*
[x11,-3],[x12,0.5],[x22,0.15],[y1,1],[y2,0.15],[r,1]
[2.948670364423784504,0.5817985920578351965,0.4754127542095007750,0.6566284657983176130]

[2416] test_fb1_intval2(1.5,0.15);
[3.328683952607670791,0.9543795613234228032,0.5838382893208234475,0.8506632743913821121]

[2415] test_fb1_intval2(0.5,0.5);
[3.008345284517205504,0.3466768320872195808,1.188013939056923525,0.5896346310487693952]

[2417] test_fb1_intval2(1.5,0.5);
[3.689403684030452065,1.069701973125068140,1.494456604710335545,0.9187668797791586130]

*/


/* ѿˤĤ y  yy ޤư */
void move(double y, double yy, double *val, int (*sys_y)(double, const double, double *, void *))
{
	/* Runge-Kutta-Fehlberg(4,5) */
        const gsl_odeiv_step_type *T = gsl_odeiv_step_rkf45;
        gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 4);
        gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
        gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(4);
        gsl_odeiv_system sys = {sys_y, NULL, 4, NULL};

	double h = 1e-6;
	if (y <= yy) {
		while (y < yy) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y, yy, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y, val[0], val[1], val[2], val[3]);
		}
	} else {
		h = -h;
		while (y < yy) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y, yy, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y, val[0], val[1], val[2], val[3]);
		}

	}
	gsl_odeiv_evolve_free(e);
        gsl_odeiv_control_free(c);
        gsl_odeiv_step_free(s);
}

/* pf1, pf2 ȤäƤ (y1,y2) Ǥͤ顢 (yy1,y2) Ǥͤ */
void move_y1(double y1, double yy1, double *val)
{
	/* Runge-Kutta-Fehlberg(4,5) */
        const gsl_odeiv_step_type *T = gsl_odeiv_step_rkf45;
        gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 4);
        gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
        gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(4);
        gsl_odeiv_system sys = {sys_y1, NULL, 4, NULL};

	double h = 1e-6;
	if (y1 <= yy1) {
		while (y1 < yy1) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y1, yy1, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y1, val[0], val[1], val[2], val[3]);
		}
	} else {
		h = -h;
		while (y1 < yy1) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y1, yy1, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y1, val[0], val[1], val[2], val[3]);
		}

	}
	gsl_odeiv_evolve_free(e);
        gsl_odeiv_control_free(c);
        gsl_odeiv_step_free(s);
}

int sys_y1(double y1, const double *y, double *val, double *params)
{
extern gsl_matrix *pf1_m;
extern double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;
	int i, j;

	pf1(g_x11, g_x12, g_x22, y1, g_y2, g_r);
	for (i = 0; i < 4; i++) {
		val[i] = 0.0;
		for (j = 0; j < 4; j++)
			val[i] += gsl_matrix_get(pf1_m, i, j) * y[j];
	}	
	return GSL_SUCCESS;
}

/* pf1, pf2 ȤäƤ (y1,y2) Ǥͤ顢 (y1,yy2) Ǥͤ */
void move_y2(double y2, double yy2, double *val)
{
	/* Runge-Kutta-Fehlberg(4,5) */
        const gsl_odeiv_step_type *T = gsl_odeiv_step_rkf45;
        gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 4);
        gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
        gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(4);
        gsl_odeiv_system sys = {sys_y2, NULL, 4, NULL};

	double h = 1e-6;
	if (y2 <= yy2) {
		while (y2 < yy2) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y2, yy2, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y2, val[0], val[1], val[2], val[3]);
		}
	} else {
		h = -h;
		while (y2 < yy2) {
			int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y2, yy2, &h, val);
			if (status != GSL_SUCCESS) break;
			printf("%f %f %f %f %f\n", y2, val[0], val[1], val[2], val[3]);
		}

	}
	gsl_odeiv_evolve_free(e);
        gsl_odeiv_control_free(c);
        gsl_odeiv_step_free(s);
}

int sys_y2(double y2, const double *y, double *val, double *params)
{
extern gsl_matrix *pf2_m;
extern double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;
	int i, j;

	pf2(g_x11, g_x12, g_x22, g_y1, y2, g_r);
	for (i = 0; i < 4; i++) {
		val[i] = 0.0;
		for (j = 0; j < 4; j++)
			val[i] += gsl_matrix_get(pf2_m, i, j) * y[j];
	}	
	return GSL_SUCCESS;
}

void set_abce_1(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *b1, *c1, *e1;
gsl_matrix_set(a1, 0, 0, 1);
gsl_matrix_set(a1, 1, 1, 1);
gsl_matrix_set(a1, 2, 1, 1*x12);
gsl_matrix_set(a1, 2, 2, (-2)*x11 + 2*x22);
gsl_matrix_set(a1, 3, 3, 1);
gsl_matrix_set(b1, 0, 1, 1);
gsl_matrix_set(b1, 1, 3, 1);
gsl_matrix_set(b1, 2, 0, 1*x12*r*r);
gsl_matrix_set(b1, 2, 1, (-1)*y2);
gsl_matrix_set(b1, 2, 2, 1*y1);
gsl_matrix_set(b1, 2, 3, (-1)*x12);
gsl_matrix_set(e1, 3, 0, 1);
}

void set_abce_2(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a2, *b2, *c2, *e2;
gsl_matrix_set(a2, 0, 0, 1);
gsl_matrix_set(a2, 1, 1, 2*x11 + (-2)*x22);
gsl_matrix_set(a2, 1, 2, 1*x12);
gsl_matrix_set(a2, 2, 2, 1);
gsl_matrix_set(a2, 3, 3, (-2)*x11 + 2*x22);
gsl_matrix_set(b2, 0, 2, 1);
gsl_matrix_set(b2, 1, 1, 1*y2);
gsl_matrix_set(b2, 1, 2, (-1)*y1);
gsl_matrix_set(b2, 1, 3, 1*x12);
gsl_matrix_set(b2, 2, 0, 1*r*r);
gsl_matrix_set(b2, 2, 3, (-1));
gsl_matrix_set(b2, 3, 1, 1*x12*r*r);
gsl_matrix_set(b2, 3, 2, 1);
gsl_matrix_set(b2, 3, 3, (-1)*y2);
gsl_matrix_set(c2, 3, 0, 1*y1);
gsl_matrix_set(e2, 3, 0, (-2)*x12);
}

void set_pqr(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *p2, *q2, *p3, *q3, *r3;
gsl_matrix_set(p2, 0, 0, (-2)*x11 + 2*x22);
gsl_matrix_set(q2, 0, 0, (-1)*x12*r*r);
gsl_matrix_set(q2, 0, 1, 1*y2);
gsl_matrix_set(q2, 0, 2, (-1)*y1);
gsl_matrix_set(q2, 0, 3, 2*x12);
gsl_matrix_set(p3, 0, 0, 2*x11 + (-2)*x22);
gsl_matrix_set(p3, 0, 1, 2*x12);
gsl_matrix_set(p3, 1, 0, 2*x12);
gsl_matrix_set(p3, 1, 1, (-2)*x11 + 2*x22);
gsl_matrix_set(q3, 0, 0, 1*y2);
gsl_matrix_set(q3, 1, 0, (-1)*y1);
gsl_matrix_set(r3, 0, 0, (-1)*y1*r*r);
gsl_matrix_set(r3, 0, 1, (-2)*x11*r*r + 2*r*r*x22 + 1);
gsl_matrix_set(r3, 0, 2, (-1)*x12*r*r);
gsl_matrix_set(r3, 0, 3, 1*y1);
gsl_matrix_set(r3, 1, 1, (-1)*x12*r*r);
gsl_matrix_set(r3, 1, 2, (-1));
gsl_matrix_set(r3, 1, 3, 1*y2);
}

void set_dbcqr(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;
gsl_matrix_set(db11, 2, 2, 1);
gsl_matrix_set(db12, 2, 1, (-1));
gsl_matrix_set(db21, 1, 2, (-1));
gsl_matrix_set(db22, 1, 1, 1);
gsl_matrix_set(db22, 3, 3, (-1));
gsl_matrix_set(dc21, 3, 0, 1);
gsl_matrix_set(dq21, 0, 2, (-1));
gsl_matrix_set(dq22, 0, 1, 1);
gsl_matrix_set(dq31, 1, 0, (-1));
gsl_matrix_set(dq32, 0, 0, 1);
gsl_matrix_set(dr31, 0, 0, (-1)*r*r);
gsl_matrix_set(dr31, 0, 3, 1);
gsl_matrix_set(dr32, 1, 3, 1);
}

void pf1(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m;

set_abce_1(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
invmat(a1, inv_a1);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t1, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
gsl_matrix_sub(t3, r3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, b1);
gsl_matrix_sub(t5, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t2);
gsl_matrix_memcpy(pf1_m, t2);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
}

void pf2(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf2_m;

set_abce_2(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
invmat(a2, inv_a2);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t1, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
gsl_matrix_sub(t3, r3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, b2);
gsl_matrix_sub(t5, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t2);
gsl_matrix_memcpy(pf2_m, t2);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
}

void pf11(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m, *pf2_m;
extern gsl_matrix *pf11_m, *pf12_m, *pf21_m, *pf22_m;
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;

set_abce_1(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
set_dbcqr(x11, x12, x22, y1, y2, r);
invmat(a1, inv_a1);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

pf1(x11, x12, x22, y1, y2, r);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq21, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq31, t1, 0.0, t3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr31);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, db11); 
gsl_matrix *t6 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc11, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf1_m, pf1_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf11_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);
}

void pf12(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m, *pf2_m;
extern gsl_matrix *pf11_m, *pf12_m, *pf21_m, *pf22_m;
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;

set_abce_1(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
set_dbcqr(x11, x12, x22, y1, y2, r);
invmat(a1, inv_a1);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

pf1(x11, x12, x22, y1, y2, r);
pf2(x11, x12, x22, y1, y2, r);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq22, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq32, t1, 0.0, t3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr32);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, db12); 
gsl_matrix *t6 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc12, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf1_m, pf2_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf12_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);
}

void pf21(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m, *pf2_m;
extern gsl_matrix *pf11_m, *pf12_m, *pf21_m, *pf22_m;
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;

set_abce_2(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
set_dbcqr(x11, x12, x22, y1, y2, r);
invmat(a2, inv_a2);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

pf2(x11, x12, x22, y1, y2, r);
pf1(x11, x12, x22, y1, y2, r);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq21, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq31, t1, 0.0, t3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr31);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, db21); 
gsl_matrix *t6 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc21, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf2_m, pf1_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf21_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);
}

void pf22(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m, *pf2_m;
extern gsl_matrix *pf11_m, *pf12_m, *pf21_m, *pf22_m;
extern gsl_matrix *db11, *db12, *db21, *db22, *dc11, *dc12, *dc21, *dc22, *dq21, *dq22, *dq31, *dq32, *dr31, *dr32;

set_abce_2(x11, x12, x22, y1, y2, r);
set_pqr(x11, x12, x22, y1, y2, r);
set_dbcqr(x11, x12, x22, y1, y2, r);
invmat(a2, inv_a2);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

pf2(x11, x12, x22, y1, y2, r);

gsl_matrix *t1 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
gsl_matrix *t2 = gsl_matrix_alloc(1,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq22, 0.0, t2);
gsl_matrix *t3 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq32, t1, 0.0, t3);
gsl_matrix *t4 = gsl_matrix_alloc(2,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr32);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
gsl_matrix *t5 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, db22); 
gsl_matrix *t6 = gsl_matrix_alloc(4,4);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc22, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf2_m, pf2_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf22_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);
}

void invmat(gsl_matrix *m, gsl_matrix *invm)
{
	int n = m->size1;
	int s;
	gsl_permutation *p = gsl_permutation_alloc(n);

	gsl_linalg_LU_decomp(m, p, &s);
	gsl_linalg_LU_invert(m, p, invm);

	gsl_permutation_free(p);
}

void test_invmat()
{
	gsl_matrix *invm = gsl_matrix_alloc(3,3);	
	gsl_matrix *c = gsl_matrix_alloc(3,3);	
	gsl_matrix *mm = gsl_matrix_alloc(3,3);	
	gsl_matrix *mmm = gsl_matrix_alloc(3,3);	

	gsl_matrix_set(mm, 0, 0, 1.0);
	gsl_matrix_set(mm, 0, 1, 2.0);
	gsl_matrix_set(mm, 0, 2, 3.0);
	gsl_matrix_set(mm, 1, 0, 4.0);
	gsl_matrix_set(mm, 1, 2, 5.0);
	gsl_matrix_set(mm, 1, 2, 6.0);
	gsl_matrix_set(mm, 2, 0, 7.0);
	gsl_matrix_set(mm, 2, 1, 1.0);
	gsl_matrix_set(mm, 2, 2, 9.0);
	gsl_matrix_memcpy(mmm, mm);
	invmat(mm, invm);
	gsl_matrix_show(invm);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, mmm, invm, 0.0, c);
	gsl_matrix_show(c);

	gsl_matrix_free(invm);
	gsl_matrix_free(c);
	gsl_matrix_free(mm);
	gsl_matrix_free(mmm);
}

void gsl_matrix_show(gsl_matrix *mat)
{
	int i, j, m, n;

	m = mat->size1;
	n = mat->size2;
	for (i = 0; i < m; i++) {
		for (j = 0; j < n; j++) 
			printf("%8f ", gsl_matrix_get(mat, i, j));
		printf("\n");
	}
}

