/* gcc gsl_matrix_test.c -lgsl -lblas on orange */
/* FB1 */
#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_odeiv.h>

/*
../../Prog/fb1_intval_test.rr

initial point
[x11,-3],[x12,0.5],[x22,0.15],[y1,1],[y2,0.15],[r,1] 
[2.948670364423784504,0.5817985920578351965,0.4754127542095007750,0.6566284657983176130]

[2171] test_fb1_intval2(1.5, 0.15);
[3.328683952607670791,0.9543795613234228032,0.5838382893208234475,0.8506632743913821121]
[

*/


gsl_matrix *a1, *inv_a1, *b1, *c1, *e1; 
gsl_matrix *a2, *inv_a2, *b2, *c2, *e2; 
gsl_matrix *p2, *inv_p2, *q2; 
gsl_matrix *p3, *inv_p3, *q3, *r3; 
gsl_matrix *pf_y1;

double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;

int rf(double y1, const double *y, double *val, void *params);
void set_abce_1(double x11, double x12, double x22, double y1, double y2, double r);
void pf1(gsl_matrix *h1, double x11, double x12, double x22, double y1, double y2, double r);
void invmat(gsl_matrix *m, gsl_matrix *invm);
void test_invmat();
void gsl_matrix_show(gsl_matrix *mat);

int main()
{
	/*            x11 , x12, x22 , y1 , y2  , r  */ 
	double p[] = {-3.0, 0.5, 0.15, 1.0, 0.15, 1.0};
	double x11,x12,x22,y1,y2,r;
	x11 = -3.0; x12 = 0.5; x22 = 0.15; 
	y1 = 1.0; y2 = 0.15; r = 1.0;

	/* initial value */
	double val[] = 
{2.948670364423784504,0.5817985920578351965,0.4754127542095007750,0.6566284657983176130};


extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1; 
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2; 
extern gsl_matrix *p2, *inv_p2, *q2; 
extern gsl_matrix *p3, *inv_p3, *q3, *r3; 
extern gsl_matrix *pf_y1;

	a1 = gsl_matrix_alloc(4,4);
	inv_a1 = gsl_matrix_alloc(4,4);
	b1 = gsl_matrix_alloc(4,4);
	c1 = gsl_matrix_alloc(4,1);
	e1 = gsl_matrix_alloc(4,2);

	a2 = gsl_matrix_alloc(4,4);
	inv_a2 = gsl_matrix_alloc(4,4);
	b2 = gsl_matrix_alloc(4,4);
	c2 = gsl_matrix_alloc(4,1);
	e2 = gsl_matrix_alloc(4,2);

	p2 = gsl_matrix_alloc(1,1);
	inv_p2 = gsl_matrix_alloc(1,1);
	q2 = gsl_matrix_alloc(1,4);

	p3 = gsl_matrix_alloc(2,2);
	inv_p3 = gsl_matrix_alloc(2,2);
	q3 = gsl_matrix_alloc(2,1);
	r3 = gsl_matrix_alloc(2,4);

	pf_y1 = gsl_matrix_alloc(4,4);

extern  double g_x11, g_x12, g_x22, g_y1, g_y2, g_r;
	g_x11 = -3.0; g_x12 = 0.5; g_x22 = 0.15; 
	g_y2 = 0.15; g_r = 1.0;
	y1 = 1.0;

	/* Runge-Kutta-Fehlberg(4,5) */
	const gsl_odeiv_step_type *T = gsl_odeiv_step_rkf45;
	gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, 4);
	gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
	gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(4);
	gsl_odeiv_system sys = {rf, NULL, 4, NULL};

	double h = 1e-6; /* ƥåν */
	double goal = 1.5;

	while (y1 < goal) {
		int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &y1, goal, &h, val);
		if (status != GSL_SUCCESS) break;
		printf("%f %f %f %f %f\n", y1, val[0], val[1], val[2], val[3]);
	}

	gsl_odeiv_evolve_free(e);
	gsl_odeiv_control_free(c);
	gsl_odeiv_step_free(s);
	gsl_matrix_free(pf_y1);

}

int rf(double y1, const double *y, double *val, void *params)
{
extern gsl_matrix *pf_y1;
extern double g_x11, g_x12, g_x22, g_y2, g_r;
	int i, j;

	pf1(pf_y1, g_x11, g_x12, g_x22, y1, g_y2, g_r);

	for (i = 0; i < 4; i++) {
		val[i] = 0.0;
		for (j = 0; j < 4; j++)
			val[i] += gsl_matrix_get(pf_y1, i, j) * y[j];
	}

	return GSL_SUCCESS;
}

void set_abce_1(double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1; 
extern gsl_matrix *p2, *inv_p2, *q2; 
extern gsl_matrix *p3, *inv_p3, *q3, *r3; 

	gsl_matrix_set(a1, 0, 0, 1);
	gsl_matrix_set(a1, 1, 1, 1);
	gsl_matrix_set(a1, 2, 1, x12);
	gsl_matrix_set(a1, 2, 2, -2*x11+2*x22);
	gsl_matrix_set(a1, 3, 3, 1);

	gsl_matrix_set(b1, 0, 1, 1);
	gsl_matrix_set(b1, 1, 3, 1);
	gsl_matrix_set(b1, 2, 0, r*r*x12);
	gsl_matrix_set(b1, 2, 1, -y2);
	gsl_matrix_set(b1, 2, 2, y1);
	gsl_matrix_set(b1, 2, 3, -x12);

	gsl_matrix_set(e1, 3, 0, 1);

	gsl_matrix_set(p2, 0, 0, -2*x11+2*x22);

	gsl_matrix_set(q2, 0, 0, -r*r*x12);
	gsl_matrix_set(q2, 0, 1, y2);
	gsl_matrix_set(q2, 0, 2, -y1);
	gsl_matrix_set(q2, 0, 3, 2*x12);

	gsl_matrix_set(p3, 0, 0, 2*x11-2*x22);
	gsl_matrix_set(p3, 0, 1, 2*x12);
	gsl_matrix_set(p3, 1, 0, 2*x12);
	gsl_matrix_set(p3, 1, 1, -2*x11+2*x22);

	gsl_matrix_set(q3, 0, 0, y2);
	gsl_matrix_set(q3, 1, 0, -y1);

	gsl_matrix_set(r3, 0, 0, -r*r*y1);
	gsl_matrix_set(r3, 0, 1, -2*r*r*x11+2*x22*r*r+1);
	gsl_matrix_set(r3, 0, 2, -r*r*x12*y1);
	gsl_matrix_set(r3, 0, 3, y1);
	gsl_matrix_set(r3, 1, 0, 0);
	gsl_matrix_set(r3, 1, 1, -r*r*x12);
	gsl_matrix_set(r3, 1, 2, -1);
	gsl_matrix_set(r3, 1, 3, y2);

	invmat(p2, inv_p2);
	invmat(p3, inv_p3);
	invmat(a1, inv_a1);
}

void pf1(gsl_matrix *h1, double x11, double x12, double x22, double y1, double y2, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1; 
extern gsl_matrix *p2, *inv_p2, *q2; 
extern gsl_matrix *p3, *inv_p3, *q3, *r3; 

	set_abce_1(x11,x12,x22,y1,y2,r);

	/* \partial_{y1} F = H_1 F */
	gsl_matrix *t1 = gsl_matrix_alloc(1,4);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
	gsl_matrix *t2 = gsl_matrix_alloc(4,4);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t1, 0.0, t2);
	gsl_matrix *t3 = gsl_matrix_alloc(2,4);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
	gsl_matrix_sub(t3, r3);
	gsl_matrix *t4 = gsl_matrix_alloc(2,4);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
	gsl_matrix *t5 = gsl_matrix_alloc(4,4);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
	gsl_matrix_add(t5, b1);
	gsl_matrix_sub(t5, t2);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t2);
	gsl_matrix_memcpy(h1, t2);

	gsl_matrix_free(t1);
	gsl_matrix_free(t2);
	gsl_matrix_free(t3);
	gsl_matrix_free(t4);
	gsl_matrix_free(t5);
}

void invmat(gsl_matrix *m, gsl_matrix *invm)
{
	int n = m->size1;
	int s;
	gsl_permutation *p = gsl_permutation_alloc(n);

	gsl_linalg_LU_decomp(m, p, &s);
	gsl_linalg_LU_invert(m, p, invm);

	gsl_permutation_free(p);
}

void test_invmat()
{
	gsl_matrix *invm = gsl_matrix_alloc(3,3);	
	gsl_matrix *c = gsl_matrix_alloc(3,3);	
	gsl_matrix *mm = gsl_matrix_alloc(3,3);	
	gsl_matrix *mmm = gsl_matrix_alloc(3,3);	

	gsl_matrix_set(mm, 0, 0, 1.0);
	gsl_matrix_set(mm, 0, 1, 2.0);
	gsl_matrix_set(mm, 0, 2, 3.0);
	gsl_matrix_set(mm, 1, 0, 4.0);
	gsl_matrix_set(mm, 1, 2, 5.0);
	gsl_matrix_set(mm, 1, 2, 6.0);
	gsl_matrix_set(mm, 2, 0, 7.0);
	gsl_matrix_set(mm, 2, 1, 1.0);
	gsl_matrix_set(mm, 2, 2, 9.0);
	gsl_matrix_memcpy(mmm, mm);
	invmat(mm, invm);
	gsl_matrix_show(invm);
	gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, mmm, invm, 0.0, c);
	gsl_matrix_show(c);

	gsl_matrix_free(invm);
	gsl_matrix_free(c);
	gsl_matrix_free(mm);
	gsl_matrix_free(mmm);
}

void gsl_matrix_show(gsl_matrix *mat)
{
	int i, j, m, n;

	m = mat->size1;
	n = mat->size2;
	for (i = 0; i < m; i++) {
		for (j = 0; j < n; j++) 
			printf("%8f ", gsl_matrix_get(mat, i, j));
		printf("\n");
	}
}

