#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_odeiv.h>
#include <gsl/gsl_multimin.h>

#define N_VALUES 16
#define DIM 44
#define ODEIV_STEP_TYPE gsl_odeiv_step_rkf45
#define MOVE_T_SUCCESS 1
#define MOVE_T_FAIL    0
#define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fdfminimizer_conjugate_fr 
/*
#define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fdfminimizer_steepest_descent
*/
#define MAXSIZE 10

const gsl_multimin_fdfminimizer_type *g_minimizer_type;

gsl_matrix *a1, *b1, *c1, *e1;
gsl_matrix *a2, *b2, *c2, *e2;
gsl_matrix *a3, *b3, *c3, *e3;
gsl_matrix *a4, *b4, *c4, *e4;
gsl_matrix *a5, *b5, *c5, *e5;
gsl_matrix *a6, *b6, *c6, *e6;
gsl_matrix *a7, *b7, *c7, *e7;
gsl_matrix *a8, *b8, *c8, *e8;
gsl_matrix *p2, *q2, *p3, *q3, *r3;
gsl_matrix *db11;
gsl_matrix *dc11;
gsl_matrix *db12;
gsl_matrix *dc12;
gsl_matrix *db13;
gsl_matrix *dc13;
gsl_matrix *db14;
gsl_matrix *dc14;
gsl_matrix *db15;
gsl_matrix *dc15;
gsl_matrix *db16;
gsl_matrix *dc16;
gsl_matrix *db17;
gsl_matrix *dc17;
gsl_matrix *db18;
gsl_matrix *dc18;
gsl_matrix *db21;
gsl_matrix *dc21;
gsl_matrix *db22;
gsl_matrix *dc22;
gsl_matrix *db23;
gsl_matrix *dc23;
gsl_matrix *db24;
gsl_matrix *dc24;
gsl_matrix *db25;
gsl_matrix *dc25;
gsl_matrix *db26;
gsl_matrix *dc26;
gsl_matrix *db27;
gsl_matrix *dc27;
gsl_matrix *db28;
gsl_matrix *dc28;
gsl_matrix *db31;
gsl_matrix *dc31;
gsl_matrix *db32;
gsl_matrix *dc32;
gsl_matrix *db33;
gsl_matrix *dc33;
gsl_matrix *db34;
gsl_matrix *dc34;
gsl_matrix *db35;
gsl_matrix *dc35;
gsl_matrix *db36;
gsl_matrix *dc36;
gsl_matrix *db37;
gsl_matrix *dc37;
gsl_matrix *db38;
gsl_matrix *dc38;
gsl_matrix *db41;
gsl_matrix *dc41;
gsl_matrix *db42;
gsl_matrix *dc42;
gsl_matrix *db43;
gsl_matrix *dc43;
gsl_matrix *db44;
gsl_matrix *dc44;
gsl_matrix *db45;
gsl_matrix *dc45;
gsl_matrix *db46;
gsl_matrix *dc46;
gsl_matrix *db47;
gsl_matrix *dc47;
gsl_matrix *db48;
gsl_matrix *dc48;
gsl_matrix *db51;
gsl_matrix *dc51;
gsl_matrix *db52;
gsl_matrix *dc52;
gsl_matrix *db53;
gsl_matrix *dc53;
gsl_matrix *db54;
gsl_matrix *dc54;
gsl_matrix *db55;
gsl_matrix *dc55;
gsl_matrix *db56;
gsl_matrix *dc56;
gsl_matrix *db57;
gsl_matrix *dc57;
gsl_matrix *db58;
gsl_matrix *dc58;
gsl_matrix *db61;
gsl_matrix *dc61;
gsl_matrix *db62;
gsl_matrix *dc62;
gsl_matrix *db63;
gsl_matrix *dc63;
gsl_matrix *db64;
gsl_matrix *dc64;
gsl_matrix *db65;
gsl_matrix *dc65;
gsl_matrix *db66;
gsl_matrix *dc66;
gsl_matrix *db67;
gsl_matrix *dc67;
gsl_matrix *db68;
gsl_matrix *dc68;
gsl_matrix *db71;
gsl_matrix *dc71;
gsl_matrix *db72;
gsl_matrix *dc72;
gsl_matrix *db73;
gsl_matrix *dc73;
gsl_matrix *db74;
gsl_matrix *dc74;
gsl_matrix *db75;
gsl_matrix *dc75;
gsl_matrix *db76;
gsl_matrix *dc76;
gsl_matrix *db77;
gsl_matrix *dc77;
gsl_matrix *db78;
gsl_matrix *dc78;
gsl_matrix *db81;
gsl_matrix *dc81;
gsl_matrix *db82;
gsl_matrix *dc82;
gsl_matrix *db83;
gsl_matrix *dc83;
gsl_matrix *db84;
gsl_matrix *dc84;
gsl_matrix *db85;
gsl_matrix *dc85;
gsl_matrix *db86;
gsl_matrix *dc86;
gsl_matrix *db87;
gsl_matrix *dc87;
gsl_matrix *db88;
gsl_matrix *dc88;
gsl_matrix *dq21;
gsl_matrix *dq31;
gsl_matrix *dr31;
gsl_matrix *dq22;
gsl_matrix *dq32;
gsl_matrix *dr32;
gsl_matrix *dq23;
gsl_matrix *dq33;
gsl_matrix *dr33;
gsl_matrix *dq24;
gsl_matrix *dq34;
gsl_matrix *dr34;
gsl_matrix *dq25;
gsl_matrix *dq35;
gsl_matrix *dr35;
gsl_matrix *dq26;
gsl_matrix *dq36;
gsl_matrix *dr36;
gsl_matrix *dq27;
gsl_matrix *dq37;
gsl_matrix *dr37;
gsl_matrix *dq28;
gsl_matrix *dq38;
gsl_matrix *dr38;
gsl_matrix *inv_a1;
gsl_matrix *inv_a2;
gsl_matrix *inv_a3;
gsl_matrix *inv_a4;
gsl_matrix *inv_a5;
gsl_matrix *inv_a6;
gsl_matrix *inv_a7;
gsl_matrix *inv_a8;
gsl_matrix *inv_p2;
gsl_matrix *inv_p3;
gsl_matrix *pf1_m;
gsl_matrix *pf2_m;
gsl_matrix *pf3_m;
gsl_matrix *pf4_m;
gsl_matrix *pf5_m;
gsl_matrix *pf6_m;
gsl_matrix *pf7_m;
gsl_matrix *pf8_m;
gsl_matrix *pf1_nd_m;
gsl_matrix *pf2_nd_m;
gsl_matrix *pf3_nd_m;
gsl_matrix *pf4_nd_m;
gsl_matrix *pf5_nd_m;
gsl_matrix *pf6_nd_m;
gsl_matrix *pf7_nd_m;
gsl_matrix *pf8_nd_m;
gsl_matrix *pf11_m;
gsl_matrix *pf12_m;
gsl_matrix *pf13_m;
gsl_matrix *pf14_m;
gsl_matrix *pf15_m;
gsl_matrix *pf16_m;
gsl_matrix *pf17_m;
gsl_matrix *pf18_m;
gsl_matrix *pf22_m;
gsl_matrix *pf23_m;
gsl_matrix *pf24_m;
gsl_matrix *pf25_m;
gsl_matrix *pf26_m;
gsl_matrix *pf27_m;
gsl_matrix *pf28_m;
gsl_matrix *pf33_m;
gsl_matrix *pf34_m;
gsl_matrix *pf35_m;
gsl_matrix *pf36_m;
gsl_matrix *pf37_m;
gsl_matrix *pf38_m;
gsl_matrix *pf44_m;
gsl_matrix *pf45_m;
gsl_matrix *pf46_m;
gsl_matrix *pf47_m;
gsl_matrix *pf48_m;
gsl_matrix *pf55_m;
gsl_matrix *pf56_m;
gsl_matrix *pf57_m;
gsl_matrix *pf58_m;
gsl_matrix *pf66_m;
gsl_matrix *pf67_m;
gsl_matrix *pf68_m;
gsl_matrix *pf77_m;
gsl_matrix *pf78_m;
gsl_matrix *pf88_m;
gsl_matrix *pft_m;
gsl_vector *grad_v;
double g_y1;
double g_y2;
double g_y3;
double g_y4;
double g_y5;
double g_y6;
double g_y7;
double g_y8;
double g_x11;
double g_x12;
double g_x13;
double g_x14;
double g_x15;
double g_x16;
double g_x17;
double g_x18;
double g_x22;
double g_x23;
double g_x24;
double g_x25;
double g_x26;
double g_x27;
double g_x28;
double g_x33;
double g_x34;
double g_x35;
double g_x36;
double g_x37;
double g_x38;
double g_x44;
double g_x45;
double g_x46;
double g_x47;
double g_x48;
double g_x55;
double g_x56;
double g_x57;
double g_x58;
double g_x66;
double g_x67;
double g_x68;
double g_x77;
double g_x78;
double g_x88;
double g_r;
double g_s1;
double g_s2;
double g_s3;
double g_s4;
double g_s5;
double g_s6;
double g_s7;
double g_s8;
double g_s11;
double g_s12;
double g_s13;
double g_s14;
double g_s15;
double g_s16;
double g_s17;
double g_s18;
double g_s22;
double g_s23;
double g_s24;
double g_s25;
double g_s26;
double g_s27;
double g_s28;
double g_s33;
double g_s34;
double g_s35;
double g_s36;
double g_s37;
double g_s38;
double g_s44;
double g_s45;
double g_s46;
double g_s47;
double g_s48;
double g_s55;
double g_s56;
double g_s57;
double g_s58;
double g_s66;
double g_s67;
double g_s68;
double g_s77;
double g_s78;
double g_s88;
double values[N_VALUES];
double move_t_points[DIM];

void init_mat();
void set_abce_1(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_2(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_3(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_4(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_5(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_6(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_7(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_abce_8(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_pqr(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void set_dbcqr(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf1(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf1_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf2(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf2_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf3(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf3_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf4(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf4_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf5(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf5_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf6(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf6_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf7(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf7_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf8(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf8_no_diag_shift(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf11(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf12(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf13(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf14(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf15(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf16(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf17(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf18(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf21(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf22(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf23(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf24(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf25(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf26(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf27(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf28(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf31(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf32(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf33(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf34(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf35(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf36(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf37(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf38(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf41(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf42(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf43(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf44(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf45(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf46(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf47(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf48(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf51(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf52(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf53(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf54(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf55(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf56(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf57(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf58(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf61(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf62(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf63(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf64(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf65(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf66(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf67(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf68(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf71(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf72(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf73(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf74(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf75(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf76(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf77(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf78(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf81(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf82(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf83(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf84(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf85(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf86(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf87(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf88(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void pf_all(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r);
void invmat(gsl_matrix *m, gsl_matrix *invm);
void gsl_matrix_show(gsl_matrix *mat);
int move_t(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double xx11, double xx12, double xx13, double xx14, double xx15, double xx16, double xx17, double xx18, double xx22, double xx23, double xx24, double xx25, double xx26, double xx27, double xx28, double xx33, double xx34, double xx35, double xx36, double xx37, double xx38, double xx44, double xx45, double xx46, double xx47, double xx48, double xx55, double xx56, double xx57, double xx58, double xx66, double xx67, double xx68, double xx77, double xx78, double xx88, double yy1, double yy2, double yy3, double yy4, double yy5, double yy6, double yy7, double yy8, double *val);
int sys_t(double t, const double *y, double *val, double *params);
double *fbnd(int dim, double x[MAXSIZE][MAXSIZE], double y[], int maxdeg, int weight[]);
double my_f(const gsl_vector *v, void *params);
void my_df(const gsl_vector *v, void *param, gsl_vector *df);
void my_fdf(const gsl_vector *x, void *params, double *f, gsl_vector *df);
void gsl_vector_show(gsl_vector *mat);
void show_v(double *v, int n);
void grad(double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double r, double *val);
double *init_val(int dim, double x11, double x12, double x13, double x14, double x15, double x16, double x17, double x18, double x22, double x23, double x24, double x25, double x26, double x27, double x28, double x33, double x34, double x35, double x36, double x37, double x38, double x44, double x45, double x46, double x47, double x48, double x55, double x56, double x57, double x58, double x66, double x67, double x68, double x77, double x78, double x88, double y1, double y2, double y3, double y4, double y5, double y6, double y7, double y8, double s11, double s12, double s13, double s14, double s15, double s16, double s17, double s18, double s22, double s23, double s24, double s25, double s26, double s27, double s28, double s33, double s34, double s35, double s36, double s37, double s38, double s44, double s45, double s46, double s47, double s48, double s55, double s56, double s57, double s58, double s66, double s67, double s68, double s77, double s78, double s88, double s1, double s2, double s3, double s4, double s5, double s6, double s7, double s8);
void search_min(double *val);
